#include "Ball.h"

Ball::Ball(const Vector2 & initPos, const Vector2 & initVel)
	:
	position(initPos),
	velocity(initVel)
{
}

void Ball::Draw(Graphics & gfx) const
{
	SpriteCodex::DrawBall(position, gfx);
}

void Ball::Update(float deltaTime)
{
	position += velocity * deltaTime;
}

bool Ball::CollisionWall(const ShapeRect & target)
{
	bool collided = false;
	const ShapeRect rect = GetRect();
	if(rect.left < target.left)
	{
		position.x += (target.left - rect.left);
		ReboundX();
		collided = true;
	}
	if(rect.top < target.top)
	{
		position.y += (target.top - rect.top);
		ReboundY();
		collided = true;
	}
	if(rect.right > target.right)
	{
		position.x += (target.right - rect.right);
		ReboundX();
		collided = true;
	}
	if(rect.bottom > target.bottom)
	{
		position.y += (target.bottom - rect.bottom);
		ReboundY();
		collided = true;
	}
	return collided;
}

void Ball::ReboundX()
{
	velocity.x = -velocity.x;
}

void Ball::ReboundY()
{
	velocity.y = -velocity.y;
}

ShapeRect Ball::GetRect()
{
	return ShapeRect(position, radius, radius, '0');
}
