#pragma once

#include "Graphics.h"
#include "SpriteCodex.h"
#include "Vector2.h"
#include "ShapeRect.h"

class Ball
{
public:
	Ball(const Vector2& initPos, const Vector2& initVel);

	void Draw(Graphics& gfx) const;
	void Update(float deltaTime);
	bool CollisionWall(const ShapeRect& target);
	void ReboundX();
	void ReboundY();
	ShapeRect GetRect();

private:
	Vector2 position;
	Vector2 velocity;
	static constexpr float radius = 7.0f;
};