#pragma once

#include "Keyboard.h"
#include "Graphics.h"
#include "Vector2.h"
#include "ShapeRect.h"
#include "Colors.h"
#include "Ball.h"

class Paddle
{
public:
	Paddle(const Vector2& initPos);

	void Draw(Graphics& gfx) const;
	void Update(Keyboard& kbd, float deltaTime);
	void WallCollision(const ShapeRect& target);
	bool BallCollision(Ball& ball) const;
	ShapeRect GetRect() const;

private:
	Vector2 position;
	float width = 60.0f;
	float height = 10.0f;
	Color bodyColour = Color(255, 255, 255);
	Color wingColour = Color(255, 10, 10);
	float wingWidth = 7.0f;
	float xVelocity = 150.0f;
};