#include "ShapeRect.h"

ShapeRect::ShapeRect(float left, float top, float right, float bottom)
	:
	left(left),
	top(top),
	right(right),
	bottom(bottom)
{
}

ShapeRect::ShapeRect(Vector2 & topLeft, Vector2 & bottomRight)
	:
	ShapeRect(topLeft.x, topLeft.y, bottomRight.x, bottomRight.y)
{
}

ShapeRect::ShapeRect(Vector2 & topLeft, float width, float height)
	:
	ShapeRect(topLeft, topLeft + Vector2(width, height))
{
}

ShapeRect::ShapeRect(Vector2 & center, float halfWidth, float halfHeight, char dummy)
	:
	ShapeRect(center - Vector2(halfWidth, halfHeight), center + Vector2(halfWidth, halfHeight))
{
}

bool ShapeRect::Overlap(const ShapeRect & target) const
{
	return left <= target.right && top <= target.bottom && right >= target.left && bottom >= target.top;
}

ShapeRect ShapeRect::GetExpanded(float offset) const
{
	return ShapeRect(left - offset, top - offset, right + offset, bottom + offset);
}
